/* 
   Significantly changed from original and no longer mobile-only
   You must add class "responsive" to your table, which should have a
   "title" attribute.   The classes "pretable" and "donetable" are displayed
   before and after table formatting, as appropriate.  You can set
   scrollDivTo to a function that should return the table row to scroll to.
   Ex: 
   var scrollDivTo = function(container) {
       var today = new Date();
       return container.find("tr:eq("+(today.getDay()+1)+")"); 
   };
   And include this:
   <script type="text/javascript" src="/js/responsive-tables.js">
</script>

   Note, it will autoload the css file from /css
   These changes and all related code c.2015 by Evan Langloois @ Eddon Systems
*/

var intervalRId = null;
var intervalLId = null;
var chromeHack = null;
var scrollbarWidth = 0;

var jumpTableLeft = function() {
    jQuery(".scrollable").scrollLeft(0);
};
var jumpTableRight = function() {
    jQuery(".scrollable").scrollLeft(2000);
};
var scrollTableLeft = function() {
    jQuery(".scrollable").scrollLeft(jQuery(".scrollable").scrollLeft() - 25);
    if (!intervalLId) {
        intervalLId = setInterval(function() {
            jQuery(".scrollable").scrollLeft(jQuery(".scrollable").scrollLeft() - 50);
        }, 100);
        jQuery(document).mouseup(function() {
            clearInterval(intervalLId);
            intervalLId = null;
        });
    }
};

var scrollTableRight = function() {
    jQuery(".scrollable").scrollLeft(jQuery(".scrollable").scrollLeft() + 25);
    if (!intervalRId) {
        intervalRId = setInterval(function() {
            jQuery(".scrollable").scrollLeft(jQuery(".scrollable").scrollLeft() + 50);
        }, 100);
        jQuery(document).mouseup(function() {
            clearInterval(intervalRId);
            intervalRId = null;
        });
    }
};


jQuery(document).ready(function() {
    var title = jQuery(".responsive").attr('title');

    jQuery('head').append('<link type="text/css" media="screen" rel="stylesheet" href="/css/responsive-tables.css" />');
    if ((jQuery.browser.mobile) && (isChromium !== null || isOpera !== null))
        jQuery(".responsive").before("<p><strong>Sorry!</strong> &nbsp; Mobile versions of Chrome and Opera have a weird bug where the content of a table and the borders get out of sync when scrolling it.  Scroll slowly!</p>\n");
	
    jQuery(".responsive").before("<div id=\"scrollbar-measure\"></div>" +
	"<div id=\"leftScrollArrow\"><h3 class=\"left\">&nbsp; ⇦</h3></div>" +
	"<div id=\"rightScrollArrow\"><h3 class=\"right\">⇨ &nbsp;</h3></div>" +
	"<h3 class=\"center\">" + title + "</h3>\n<div class=\"newhead\"></div>\n");
    jQuery(".responsive").clone().appendTo(".newhead");


    /* Setup Arrows */
    if (jQuery.browser.mobile) {
        jQuery('#leftScrollArrow').click(jumpTableLeft);
        jQuery('#rightScrollArrow').click(jumpTableRight);
    } else {
        jQuery('#leftScrollArrow').mousedown(scrollTableLeft);
        jQuery('#rightScrollArrow').mousedown(scrollTableRight);
    }

  var updateTables = function() {
      var cellWidths = new Array();
      var cellHeights = new Array(); 
      var i = 0;

      jQuery("table.responsive").each(function(i, element) {
        splitTable(jQuery(element));
      });


      /* ScrollBar Detection */
      var scrollDiv = document.getElementById("scrollbar-measure");
      scrollbarWidth = scrollDiv.offsetWidth - scrollDiv.clientWidth;

      var width = jQuery(".pinned:eq(1)").width();
      jQuery("div.scrollable").css("margin-left",width + "px");
      var topCorner = jQuery(".newhead .pinned thead td:first-child");
      topCorner.css("width", width + "px");
      topCorner = jQuery(".newhead .pinned thead tr:first-child");
      jQuery(".newhead .scrollable thead tr:first-child").css("height",  topCorner.css('height'));

      jQuery("div.table-wrapper:eq(0)").css("margin-bottom", "0");
      jQuery(".pinned").css("top","1px");
      jQuery(".scrollable:eq(1) tbody tr:first-child td").each(function() {
          cellWidths.push(this.clientWidth);
      });
      cellWidths[0] = width;
      i = 0;
      jQuery(".scrollable:eq(0) thead tr td").each(function() {
          cellWidths[i] = Math.max(this.clientWidth,cellWidths[i]);
          i++;
      });
      jQuery("table.responsive thead tr").hide();
      jQuery("div.newhead table.responsive thead tr").show();
      jQuery(".pinned:eq(1) thead tr").hide();

      var maxCols = i - 1;
      i = 0;
      jQuery(".scrollable:eq(1) tbody tr:first-child td").each(function() {
          var innerHTML = jQuery(this).html();
          var outerHTML = "<div style=\"width: " + (cellWidths[i]-2) + "px;\">" + innerHTML + "</div>";
          jQuery(this).html(outerHTML);
          i++;
      });
      i = 0;
      jQuery(".scrollable:eq(0) thead tr td").each(function() {
          var innerHTML = jQuery(this).html();
          if (i == maxCols)
            cellWidths[i] += scrollbarWidth;
          var outerHTML = "<div style=\"width: " + (cellWidths[i]-2) + "px;\">" + innerHTML + "</div>";
          jQuery(this).html(outerHTML);
          i++;
      });
      jQuery(".pinned:eq(1) tbody tr td:first-child").each(function() {
          var innerHTML = jQuery(this).html();
          var outerHTML = "<div style=\"width: " + (cellWidths[0]) + "px;\">" + innerHTML + "</div>";
          jQuery(this).html(outerHTML);
      });
      i = 0;
      jQuery(this).find(".scrollable:eq(1) tbody tr:first-child td").each(function() {
          var innerHTML = jQuery(this).html();
          var outerHTML = "<div style=\"width: " + (cellWidths[i++]) + "px;\">" + innerHTML + "</div>";
          jQuery(this).html(outerHTML);
      });
      jQuery(".scrollable:eq(1) tbody tr").each(function() {
          cellHeights.push(this.clientHeight);
      });
      i = 0;
      jQuery(".pinned:eq(1) tbody tr").each(function() {
          jQuery(this).height(cellHeights[i]);
          i++;
      });
      if (typeof(scrollDivTo) !== 'undefined') {
	   var container = jQuery("div.table-wrapper:eq(1)");
	   var scrollStop = scrollDivTo(container);
 	   
	   if (container !== null)
	       container.animate({
	           scrollTop: scrollStop.offset().top - container.offset().top +
				     container.scrollTop() - 1
	       });
      }
      jQuery('.scrollable').scrollLeft(0);
      jQuery('.pretable').hide();
      jQuery('.donetable').show();

   jQuery('.scrollable').on('scroll', function () {
      var MaxScroll = this.scrollWidth - this.clientWidth; /* + scrollbarWidth; */
      var scrollLTo = jQuery(this).scrollLeft();
      scrollLTo = Math.min(scrollLTo,MaxScroll);
      scrollLTo = Math.max(0,scrollLTo);
      jQuery('.scrollable').scrollLeft(scrollLTo);
      if (chromeHack)
          clearTimeout(chromeHack);
      chromeHack = setTimeout(function() {
         chromeHack = null;
         jQuery('.scrollable').scrollLeft(scrollLTo);
      }, 800);
   });
   return true;
};
   

/* The following code is written by the original author and will be phased out */
/* --------------------------------------------------------------------------- */

  jQuery(window).load(updateTables);
  /* jQuery(window).on("redraw", updateTables); */
  jQuery(window).on("resize", function() { location.reload(); } );

	function splitTable(original)
	{
		original.wrap("<div class='table-wrapper' />");
		
		var copy = original.clone();
		copy.find("td:not(:first-child), th:not(:first-child)").css("display", "none");
		copy.removeClass("responsive");
		
		original.closest(".table-wrapper").append(copy);
		copy.wrap("<div class='pinned' />");
		original.wrap("<div class='scrollable' />");

                setCellHeights(original, copy);
	}

  function setCellHeights(original, copy) {
    var tr = original.find('tr'),
        tr_copy = copy.find('tr'),
        heights = [];

    tr.each(function (index) {
      var self = jQuery(this),
          tx = self.find('th, td');

      tx.each(function () {
        var height = jQuery(this).outerHeight(true);
        heights[index] = heights[index] || 0;
        if (height > heights[index]) heights[index] = height;
      });

    });

    tr_copy.each(function (index) {
      jQuery(this).height(heights[index]);
    });
  }

});
